/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.queryhintsexample;

import jakarta.persistence.EntityManager;
import jakarta.persistence.NoResultException;
import jakarta.persistence.PersistenceContext;
import jakarta.persistence.Query;
import java.util.List;
import org.springframework.stereotype.Repository;

/**
 *
 * @author omozegieaziegbe
 */
@Repository
public class BookEntityRepository {

    @PersistenceContext
    private EntityManager entityManager;

    public List<Book> findPopularBooks() {
        String jpql = "SELECT b FROM Book b WHERE b.title > :threshold";

        Query query = entityManager.createQuery(jpql);
        query.setParameter("threshold", 1000);

        // Apply query hints programmatically
        query.setHint("org.hibernate.readOnly", true);
        query.setHint("javax.persistence.cache.storeMode", "REFRESH");

        return query.getResultList();
    }

    public Book findBookByTitle(String title) {
        try {
            // Invoke the named query with query hint
            Query query = entityManager.createNamedQuery("findBookByTitle")
                    .setParameter("title", title);

            // Execute the query and return the result
            return (Book) query.getSingleResult();
        } catch (NoResultException e) {
            return null; // Handle if no user is found
        }
    }
}
